<?php 
class ShipwayTrackModuleFrontController extends ModuleFrontController{
	public function __construct(){		
		parent::__construct();
	}
	public function init(){
		
		$this->page_name = 'shipment-track';
		$this->display_column_left = false;
		$this->display_column_right = false;
		
		parent::init();
	}
	public function initContent(){
		parent::initContent();
		
		$order_id = Tools::getValue('prst_order_id');
		$status_result = "";
		
		if(!empty($order_id)){
			$sql = " SELECT o.id_order,o.id_carrier,o.tracking_number,c.id_reference FROM " . _DB_PREFIX_ . "order_carrier o INNER JOIN " . _DB_PREFIX_. "carrier c ON(c.id_carrier = o.id_carrier) WHERE o.id_order = '" .addslashes($order_id). "' ";
			
			$orderData = Db::getInstance()->getRow($sql);
			if(!empty($orderData)){
				
				//$carrier_id = ( isset($orderData['']) ) ? ;
				
				$shipCarrierMap = Configuration::get('id_shipway_carrier');
				$shipCarrierMap = (!empty($shipCarrierMap)) ? unserialize($shipCarrierMap) : array();
		
				$username = Configuration::get('SHIPWAY_USERNAME');
				$password = Configuration::get('SHIPWAY_LINCENCE_KEY');
				$carrier_id = ( isset($orderData['id_reference']) ) ? (int)$orderData['id_reference'] : 0;
				
				$carrier_id = ( isset($shipCarrierMap[$carrier_id]) ) ? $shipCarrierMap[$carrier_id] : 0;
				$awbno 		= $orderData['tracking_number'];
				
				$strValidate = 'username|password|awbno|order_id|carrier_id';
		
				$error = array();
				foreach(explode('|',$strValidate) as $field){
					if( !isset($$field) || empty($$field) ){
						$error[] = $field;
					}
				}
				
				if(empty($error)){
					$status_result = $this->getAWBResults($username, $password, $carrier_id, $awbno,$order_id);
				}else{
					$status_result = "<p style='color:#BA1A1A;font-size:14px;'>No tracking detail associated with this order.</p>";
				}
				
				$isJson = json_decode($status_result);
				if(!empty($isJson) && strtolower($isJson->status) == 'failed'){
					$status_result = "<p style='color:#BA1A1A;font-size:14px;'>Something went wrong.Please inform the website administrator.</p>";
				}
				
			}else{
				$status_result = 'No tracking number associated with this order.';
			}
		}elseif($_SERVER['REQUEST_METHOD'] == 'POST'){
			$status_result = 'Please provide an order id.';
		}
		$this->context->smarty->assign(array(
			'action_url' 	=> $this->context->link->getModuleLink('shipway','track'),
			'trackResult'	=> $status_result
		));
	
		$this->setTemplate('shipment_track.tpl');
	}
	public function getAWBResults($username, $password, $carrier_id, $awbno, $order_id){
        $url         = "http://shipway.in/api/getawbresult";
        $data_string = array(
            "username" 		=> $username,
            "password" 		=> $password,
            "carrier_id" 	=> $carrier_id,
            "awb" 			=> $awbno,
			"order_id"		=> $order_id
        );
		
        $data_string = json_encode($data_string);
        $curl        = curl_init();
        curl_setopt($curl, CURLOPT_HTTPHEADER, array(
            'Content-Type:application/json'
        ));
        curl_setopt($curl, CURLOPT_URL, $url);
        curl_setopt($curl, CURLOPT_POST, true);
        curl_setopt($curl, CURLOPT_POSTFIELDS, $data_string);
        curl_setopt($curl, CURLOPT_RETURNTRANSFER, true);
        curl_setopt($curl, CURLOPT_FOLLOWLOCATION, 1);
        curl_setopt($curl, CURLOPT_SSL_VERIFYPEER, false);
        $output = curl_exec($curl);
        curl_close($curl);
        return $output;        
    }
}
?>